// This file is generated by kconfig_compiler from tastymenu.kcfg.
// All changes you do to this file will be lost.
#ifndef PREFS_H
#define PREFS_H

#include <kglobal.h>
#include <kconfigskeleton.h>
#include <kdebug.h>

class Prefs : public KConfigSkeleton
{
  public:
    class EnumMenuButtonLabelType
    {
      public:
      enum type { MenuButtonText, MenuButtonNone, COUNT };
    };
    class EnumMenuButtonIconType
    {
      public:
      enum type { Icon, IconNone, COUNT };
    };

    Prefs( KSharedConfig::Ptr config = KGlobal::sharedConfig() );
    ~Prefs();

    /**
      Set Size of the menu icons.
    */
    void setIconSize( int v )
    {
      if (v < 16)
      {
        kdDebug() << "setIconSize: value " << v << " is less than the minimum value of 16" << endl;
        v = 16;
      }

      if (v > 64)
      {
        kdDebug() << "setIconSize: value " << v << " is greater than the maximum value of 64" << endl;
        v = 64;
      }

      if (!isImmutable( QString::fromLatin1( "IconSize" ) ))
        mIconSize = v;
    }

    /**
      Get Size of the menu icons.
    */
    int iconSize() const
    {
      return mIconSize;
    }

    /**
      Set Size of the menu icons.
    */
    void setActionIconSize( int v )
    {
      if (v < 16)
      {
        kdDebug() << "setActionIconSize: value " << v << " is less than the minimum value of 16" << endl;
        v = 16;
      }

      if (v > 48)
      {
        kdDebug() << "setActionIconSize: value " << v << " is greater than the maximum value of 48" << endl;
        v = 48;
      }

      if (!isImmutable( QString::fromLatin1( "ActionIconSize" ) ))
        mActionIconSize = v;
    }

    /**
      Get Size of the menu icons.
    */
    int actionIconSize() const
    {
      return mActionIconSize;
    }

    /**
      Set Botton label Type
    */
    void setMenuButtonLabelType( int v )
    {
      if (!isImmutable( QString::fromLatin1( "MenuButtonLabelType" ) ))
        mMenuButtonLabelType = v;
    }

    /**
      Get Botton label Type
    */
    int menuButtonLabelType() const
    {
      return mMenuButtonLabelType;
    }

    /**
      Set Button label text to be displayed.
    */
    void setMenuButtonLabel( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "MenuButtonLabel" ) ))
        mMenuButtonLabel = v;
    }

    /**
      Get Button label text to be displayed.
    */
    QString menuButtonLabel() const
    {
      return mMenuButtonLabel;
    }

    /**
      Set Button icon Type
    */
    void setMenuButtonIconType( int v )
    {
      if (!isImmutable( QString::fromLatin1( "MenuButtonIconType" ) ))
        mMenuButtonIconType = v;
    }

    /**
      Get Button icon Type
    */
    int menuButtonIconType() const
    {
      return mMenuButtonIconType;
    }

    /**
      Set Button icon to be displayed.
    */
    void setMenuButtonIcon( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "MenuButtonIcon" ) ))
        mMenuButtonIcon = v;
    }

    /**
      Get Button icon to be displayed.
    */
    QString menuButtonIcon() const
    {
      return mMenuButtonIcon;
    }

    /**
      Set If display the application descritption under the name
    */
    void setDisplaySubText( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "DisplaySubText" ) ))
        mDisplaySubText = v;
    }

    /**
      Get If display the application descritption under the name
    */
    bool displaySubText() const
    {
      return mDisplaySubText;
    }

    /**
      Set Text of the main tooltip
    */
    void setToolTipTitle( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "ToolTipTitle" ) ))
        mToolTipTitle = v;
    }

    /**
      Get Text of the main tooltip
    */
    QString toolTipTitle() const
    {
      return mToolTipTitle;
    }

    /**
      Set Percentage of the menu width compared to screen.
    */
    void setMenuWidth( int v )
    {
      if (v < 10)
      {
        kdDebug() << "setMenuWidth: value " << v << " is less than the minimum value of 10" << endl;
        v = 10;
      }

      if (v > 90)
      {
        kdDebug() << "setMenuWidth: value " << v << " is greater than the maximum value of 90" << endl;
        v = 90;
      }

      if (!isImmutable( QString::fromLatin1( "MenuWidth" ) ))
        mMenuWidth = v;
    }

    /**
      Get Percentage of the menu width compared to screen.
    */
    int menuWidth() const
    {
      return mMenuWidth;
    }

    /**
      Set Percentage of the menu height compared to screen.
    */
    void setMenuHeight( int v )
    {
      if (v < 10)
      {
        kdDebug() << "setMenuHeight: value " << v << " is less than the minimum value of 10" << endl;
        v = 10;
      }

      if (v > 90)
      {
        kdDebug() << "setMenuHeight: value " << v << " is greater than the maximum value of 90" << endl;
        v = 90;
      }

      if (!isImmutable( QString::fromLatin1( "MenuHeight" ) ))
        mMenuHeight = v;
    }

    /**
      Get Percentage of the menu height compared to screen.
    */
    int menuHeight() const
    {
      return mMenuHeight;
    }

    /**
      Set If the three expanders should be shown in the applications list
    */
    void setShowExpander( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowExpander" ) ))
        mShowExpander = v;
    }

    /**
      Get If the three expanders should be shown in the applications list
    */
    bool showExpander() const
    {
      return mShowExpander;
    }

    /**
      Set If the applications categories should be collapsed by default
    */
    void setAlwaysCollapsed( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "AlwaysCollapsed" ) ))
        mAlwaysCollapsed = v;
    }

    /**
      Get If the applications categories should be collapsed by default
    */
    bool alwaysCollapsed() const
    {
      return mAlwaysCollapsed;
    }

    /**
      Set If the search field should perform queries with Kerry Beagle
    */
    void setKerryIntegration( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "KerryIntegration" ) ))
        mKerryIntegration = v;
    }

    /**
      Get If the search field should perform queries with Kerry Beagle
    */
    bool kerryIntegration() const
    {
      return mKerryIntegration;
    }

    /**
      Set If the search field should perform queries with Strigi.
             It has no effect when Kerry integration is enabled
    */
    void setStrigiIntegration( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "StrigiIntegration" ) ))
        mStrigiIntegration = v;
    }

    /**
      Get If the search field should perform queries with Strigi.
             It has no effect when Kerry integration is enabled
    */
    bool strigiIntegration() const
    {
      return mStrigiIntegration;
    }

    /**
      Set If Alt+F1 shortcut should be used by Tasty Menu
    */
    void setOverrideAltF1( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "OverrideAltF1" ) ))
        mOverrideAltF1 = v;
    }

    /**
      Get If Alt+F1 shortcut should be used by Tasty Menu
    */
    bool overrideAltF1() const
    {
      return mOverrideAltF1;
    }

    /**
      Set If Categories with only one child should be hidden
    */
    void setHideOneChild( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "HideOneChild" ) ))
        mHideOneChild = v;
    }

    /**
      Get If Categories with only one child should be hidden
    */
    bool hideOneChild() const
    {
      return mHideOneChild;
    }

    /**
      Set Always show entries in alphabetical order
    */
    void setAlphabetical( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "Alphabetical" ) ))
        mAlphabetical = v;
    }

    /**
      Get Always show entries in alphabetical order
    */
    bool alphabetical() const
    {
      return mAlphabetical;
    }

    /**
      Set Show "Save session" entry in the user menu
    */
    void setShowSaveSession( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "ShowSaveSession" ) ))
        mShowSaveSession = v;
    }

    /**
      Get Show "Save session" entry in the user menu
    */
    bool showSaveSession() const
    {
      return mShowSaveSession;
    }

    /**
      Set The current mode for the first column.
    */
    void setMenuMode( int v )
    {
      if (!isImmutable( QString::fromLatin1( "MenuMode" ) ))
        mMenuMode = v;
    }

    /**
      Get The current mode for the first column.
    */
    int menuMode() const
    {
      return mMenuMode;
    }

    /**
      Set currently open submenu.
    */
    void setCurrentCategory( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "CurrentCategory" ) ))
        mCurrentCategory = v;
    }

    /**
      Get currently open submenu.
    */
    QString currentCategory() const
    {
      return mCurrentCategory;
    }

    /**
      Set The list for favourite apps.
    */
    void setFavouriteApps( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "FavouriteApps" ) ))
        mFavouriteApps = v;
    }

    /**
      Get The list for favourite apps.
    */
    QStringList favouriteApps() const
    {
      return mFavouriteApps;
    }

    /**
      Set The list of all installed apps.
    */
    void setOldInstalledApps( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "OldInstalledApps" ) ))
        mOldInstalledApps = v;
    }

    /**
      Get The list of all installed apps.
    */
    QStringList oldInstalledApps() const
    {
      return mOldInstalledApps;
    }

    /**
      Set When the list of old installed apps was built.
    */
    void setOldInstalledAppsAge( int v )
    {
      if (!isImmutable( QString::fromLatin1( "OldInstalledAppsAge" ) ))
        mOldInstalledAppsAge = v;
    }

    /**
      Get When the list of old installed apps was built.
    */
    int oldInstalledAppsAge() const
    {
      return mOldInstalledAppsAge;
    }

    /**
      Set The list of recently installed apps.
    */
    void setNewInstalledApps( const QStringList & v )
    {
      if (!isImmutable( QString::fromLatin1( "NewInstalledApps" ) ))
        mNewInstalledApps = v;
    }

    /**
      Get The list of recently installed apps.
    */
    QStringList newInstalledApps() const
    {
      return mNewInstalledApps;
    }

    /**
      Set Timestamps for the list of recently installed apps.
    */
    void setNewInstalledAppsTimeStamps( const QValueList<int> & v )
    {
      if (!isImmutable( QString::fromLatin1( "NewInstalledAppsTimeStamps" ) ))
        mNewInstalledAppsTimeStamps = v;
    }

    /**
      Get Timestamps for the list of recently installed apps.
    */
    QValueList<int> newInstalledAppsTimeStamps() const
    {
      return mNewInstalledAppsTimeStamps;
    }

    /**
      Set If the menu is a Popup or a normal window
    */
    void setIsNormalWindow( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "IsNormalWindow" ) ))
        mIsNormalWindow = v;
    }

    /**
      Get If the menu is a Popup or a normal window
    */
    bool isNormalWindow() const
    {
      return mIsNormalWindow;
    }

    /**
      Set Width of the normal window (ignored in PopUp mode)
    */
    void setNormalWindowWidth( int v )
    {
      if (!isImmutable( QString::fromLatin1( "NormalWindowWidth" ) ))
        mNormalWindowWidth = v;
    }

    /**
      Get Width of the normal window (ignored in PopUp mode)
    */
    int normalWindowWidth() const
    {
      return mNormalWindowWidth;
    }

    /**
      Set Height of the normal window (ignored in PopUp mode)
    */
    void setNormalWindowHeight( int v )
    {
      if (!isImmutable( QString::fromLatin1( "NormalWindowHeight" ) ))
        mNormalWindowHeight = v;
    }

    /**
      Get Height of the normal window (ignored in PopUp mode)
    */
    int normalWindowHeight() const
    {
      return mNormalWindowHeight;
    }

    /**
      Set X coord of the normal window (ignored in PopUp mode)
    */
    void setNormalWindowX( int v )
    {
      if (!isImmutable( QString::fromLatin1( "NormalWindowX" ) ))
        mNormalWindowX = v;
    }

    /**
      Get X coord of the normal window (ignored in PopUp mode)
    */
    int normalWindowX() const
    {
      return mNormalWindowX;
    }

    /**
      Set Y coord of the normal window (ignored in PopUp mode)
    */
    void setNormalWindowY( int v )
    {
      if (!isImmutable( QString::fromLatin1( "NormalWindowY" ) ))
        mNormalWindowY = v;
    }

    /**
      Get Y coord of the normal window (ignored in PopUp mode)
    */
    int normalWindowY() const
    {
      return mNormalWindowY;
    }

  protected:

    // Appearance
    int mIconSize;
    int mActionIconSize;
    int mMenuButtonLabelType;
    QString mMenuButtonLabel;
    int mMenuButtonIconType;
    QString mMenuButtonIcon;
    bool mDisplaySubText;
    QString mToolTipTitle;
    int mMenuWidth;
    int mMenuHeight;
    bool mShowExpander;
    bool mAlwaysCollapsed;

    // Behaviour
    bool mKerryIntegration;
    bool mStrigiIntegration;
    bool mOverrideAltF1;
    bool mHideOneChild;
    bool mAlphabetical;
    bool mShowSaveSession;

    // AppState
    int mMenuMode;
    QString mCurrentCategory;
    QStringList mFavouriteApps;
    QStringList mOldInstalledApps;
    int mOldInstalledAppsAge;
    QStringList mNewInstalledApps;
    QValueList<int> mNewInstalledAppsTimeStamps;
    bool mIsNormalWindow;
    int mNormalWindowWidth;
    int mNormalWindowHeight;
    int mNormalWindowX;
    int mNormalWindowY;

  private:
};

#endif

