/***************************************************************************
 *   Copyright (C) 2006 by Marco Martin   *
 *   notmart@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TASTYTOOLTIP_H
#define TASTYTOOLTIP_H

#include <qwidget.h>
#include <qlayout.h>

#include "tastytooltipwidget.h"

/**
	@author Marco Martin <notmart@gmail.com>
*/
class TastyToolTip : public QWidget
{
public:
  TastyToolTip( QWidget * parent=0,const char * name=0, WFlags fl=WType_TopLevel);

    ~TastyToolTip();

  void showTip(const QPoint & point);
  void hideTip( );
  void loadIcon( QString iconName );
  void notify(const QPoint & point );
  void setMessage( QString message );
  void setTitle( QString title );

protected:
  virtual void mousePressEvent( QMouseEvent * e ){e=e;hide();}

private:

  QString iconName;
  TastyToolTipWidget * toolTipWidget;
  QVBoxLayout *tastyToolTipLayout;
};

#endif
